<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS v1.10                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2013                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

class p_best_comments extends cmsPlugin {

// ==================================================================== //

    public function __construct(){

        parent::__construct();

		// Информация о плагине
        $this->info['plugin']      = 'p_best_comments';
        $this->info['title']       = 'Лучшие комментарии';
        $this->info['description'] = 'Добавляет перед общими комментариями список N лучших';
        $this->info['author']      = 'InstantCMS Team';
        $this->info['version']     = '1.0';

		// События, которые будут отлавливаться плагином
        $this->events[]            = 'BEFORE_SHOW_COMMENTS';

		// Максимум для показа лучших комментариев
        $this->config['Количество']     = 3;
        $this->config['Текст названия'] = 'Лучшие комментарии';

    }

// ==================================================================== //
    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){
        return parent::install();
    }

// ==================================================================== //
    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){
          return parent::upgrade();
    }

// ==================================================================== //
    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return html
     */
    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'BEFORE_SHOW_COMMENTS': $item = $this->getBestComments($item); break;
        }

        return $item;

    }

// ==================================================================== //

    private function getBestComments($item) {

        if(!$item){ return $item; }

        if(count($item)< $this->config['Количество']){
            return $item;
        }

        $best_comments = $item;
		usort($best_comments, create_function('$a, $b', "return strcmp(\$b['rating'], \$a['rating']);")); // if php 5.2
        $best_comments = array_slice($best_comments, 0, $this->config['Количество']);

        $smarty= $this->inCore->initSmarty('plugins', 'p_best_comments.tpl');
        $smarty->assign('best_comments', $best_comments);
        $smarty->assign('bc_count', $this->config['Количество']);
        $smarty->assign('title', $this->config['Текст названия']);
        $smarty->display('p_best_comments.tpl');

        return $item;

	}

}
?>
